#include <stdlib.h>
#include "anamod.h"
#include "anamatrix.h"
#include "petscmat.h"

/*! \page anamatrix Matrix interface to AnaMod

  AnaMod uses an abstract AnaModNumericalProblem in the definition of
  ComputeQuantity() and such. For modules where the numerical problem
  is solely a Petsc matrix, MatrixComputeQuantity() is the interface.
 */
#undef __FUNCT__
#define __FUNCT__ "MatrixComputeQuantity"
PetscErrorCode MatrixComputeQuantity
(Mat A,const char *cat,const char *cmp,
 AnalysisItem *res,int *l,PetscBool *success)
{
  PetscErrorCode ierr;
  PetscFunctionBegin;
  ierr = ComputeQuantity
    ((AnaModNumericalProblem)A,cat,cmp,res,l,success); CHKERRQ(ierr);
  PetscFunctionReturn(0);
}
