/*! \file stats.c \ingroup categories 
  \brief Statistics on the AnaMod system

  \section stats Statistics on the AnaMod system

  The stats module needs to be enabled explicitly.

 */

#include <stdlib.h>
#include "anamod.h"
#include "petscerror.h"

#undef __FUNCT__
#define __FUNCT__ "Version"
/*! The AnaMod format version string
*/
static PetscErrorCode Version
(AnaModNumericalProblem prob,AnalysisItem *rv,int *l,PetscBool *flg)
{
  int id; PetscBool has; PetscErrorCode ierr;
  PetscFunctionBegin;
  ierr = GetDataID("simple","trace",&id,&has); CHKERRQ(ierr);
  HASTOEXIST(has);
  rv->c = ANAMOD_FORMAT_VERSION;
  
  PetscFunctionReturn(0);
}

#undef __FUNCT__
#define __FUNCT__ "RegisterStatsModules"
/*! Declare statistics modules
*/
PetscErrorCode RegisterStatsModules()
{
  PetscErrorCode ierr;
  PetscFunctionBegin;

  ierr = RegisterModule
    ("stats","version",ANALYSISSTRING,&Version); CHKERRQ(ierr);

  PetscFunctionReturn(0);
}
