#include <stdlib.h>
#include <stdio.h>
#include "syspro.h"
#include "sysprolinear.h"
#include "linear_impl.h"
#include "sysprosuit.h"
#include "anamod.h"
#include "linksp.h"
#include "petscmat.h"
#include "petscpc.h"
#include "petscksp.h"

/*! \section suitc Suitability functions for the linear problem 
 */
#undef __FUNCT__
#define __FUNCT__ "onlyforsymmetricproblem"
PetscErrorCode onlyforsymmetricproblem
(NumericalProblem problem,void *ctx,SuitabilityValue *v)
{
  FeatureSet features = (FeatureSet)ctx; FeatureValues values;
  AnalysisItem sn,an; PetscBool f1,f2; PetscErrorCode ierr;
  
  PetscFunctionBegin;
  ierr = NewFeatureValues(&values); CHKERRQ(ierr);
  ierr = InstantiateFeatureSet((void*)problem,features,values); CHKERRQ(ierr);
  ierr = GetFeatureValue(values,0,&sn,&f1); CHKERRQ(ierr);
  ierr = GetFeatureValue(values,1,&an,&f2); CHKERRQ(ierr);
  ierr = DeleteFeatureValues(values); CHKERRQ(ierr);
  printf("got norms: %d,%d=%e,%e\n",f1,f2,sn.r,an.r);
  *v = -1;
  if (f1 && f2 && an.r>1.e-12*sn.r) {
    printf("problem too unsymmetric\n");
    *v = 0;
  }
  PetscFunctionReturn(0);
}
